program example
    implicit none
    integer, parameter :: npts = 10000
    real, parameter :: startx=0., endx=1.
    real, parameter :: dx = (endx-startx)/npts

    real :: integral, xleft, xright, xmid
    integer :: i

    if (npts < 2) then
        print *,'Too few points!'
    else
        integral = 0.  ! Simpson's Rule
        xleft = 0.

   int: do i=0,npts-1
            xright = (i+1)*dx
            xmid = (xleft+xright)/2.

            integral = integral + (dx/6.)*(f(xleft) + 4.*f(xmid) + &
                                           f(xright))
            xleft = xright  
         end do int

         print *,'Numerical integral is ', integral
         print *,'Exact soln is ', (endx-startx)/2.  - &
                                     (sin(2*endx)-sin(2*startx))/4.
     endif 


contains

    function f(x)
        implicit none 
        real :: f
        real, intent(in) :: x
        f = sin(x)**2
    end function f

end program example


