module integrate

contains

function integratefx(xlo, xhi, f, n)
    ! integrate with trapezoid rule
    implicit none
    real, intent(in) :: xlo, xhi
    interface
        function f(x)
            implicit none
            real :: f
            real, intent(in) :: x        
        end function f
    end interface
    integer, intent(in) :: n
    real :: integratefx

    integer :: i
    real :: dx, xleft, xright

    integratefx = 0.
    dx = (xhi-xlo)/n
    xleft = xlo
    do i=0, n-1
        xright = xleft + dx
        integratefx = integratefx + dx*(f(xright)+f(xleft))/2.
        xleft = xright
    enddo 
end function integratefx

end module integrate
