module gravity
    implicit none
    private

    character (len=8), parameter, public :: massunit="kilogram"
    character (len=8), parameter, public :: forceunit="Newton"
    public :: gravforce

    real, parameter :: G  = 6.67e-11   ! MKS units

contains
    real function distance(x1,x2)
        implicit none
        real, dimension(3), intent(in) :: x1, x2

        distance = sqrt(sum((x1-x2)**2))
    end function distance

    real function gravforce(x1,x2,m1,m2)
        implicit none
        real, dimension(3), intent(in) :: x1,x2
        real, intent(in) :: m1, m2
        real :: dist

        dist = distance(x1,x2)
        gravforce = G * m1 * m2 / dist**2
    end function gravforce
end module gravity


