module gravity
    implicit none
    real, parameter :: G  = 6.67e-11   ! MKS units

contains
    real function gravforce(x1,x2,m1,m2)
        implicit none
        real, dimension(3), intent(in) :: x1,x2
        real, intent(in) :: m1, m2
        real :: dist

        dist = sqrt(sum((x1-x2)**2))
        gravforce = G * m1 * m2 / dist**2
    end function gravforce
end module gravity

program simplemod2
    use gravity, only : G, gravforce
    implicit none

    print *, 'Gravitational constant = ', G
    print *, 'Force between 2 1kg masses at [1,0,0] &
              &and [0,0,1] is'
    
    print *, gravforce([1.,0.,0.],[0.,0.,1.],1.,1.)                

end program simplemod2


