!
! F77-ized version of a Fortran90 TVD split MHD code
!
!  Original F90 code  copyright (C) 2001,2003, Ue-Li Pen
!  written November 2001 by Ue-Li Pen, pen@cita.utoronto.ca
!
! see http://arxiv.org/abs/astro-ph/0305088
! or http://www.cita.utoronto.ca/~pen/MHD
!
! This code is licencensed under the GPL
!
program hydro
  use pbm, only : outputpbm
  use solver, only : nvars, timestep, idens, initialconditions

  implicit none
  integer, parameter :: n=100,nx=n,ny=n
  real  :: t,dt
  integer :: iter
  real, dimension(nvars,nx,ny) :: u

  call initialconditions(u,nx,ny)
  call outputpbm(u,nvars,nx,ny,'ics.pbm',idens)
  t=0
  timesteps: do iter=1,nx*6
      call timestep(u,nx,ny,dt)
      t = t + 2*dt
      if (mod(iter,10).eq.1) print *, iter, 'dt = ', dt, ' t = ', t
  end do timesteps
  call outputpbm(u,nvars,nx,ny,'dens.pbm',idens)
end
